import java.awt.*;
import javax.swing.JFrame;
import javax.swing.*;

public class MainMenuView {
    private JPanel mainPanel = new JPanel(new CardLayout()); // CardLayout for switching
    private JPanel menuPanel = new JPanel(null);
    ImageIcon SoundIcon = new ImageIcon("graphics/sound button.png");
    private JFrame frame = new JFrame();
    private JLabel titelLabel = new JLabel("Studium versenken");
    private JButton lokalButton = new JButton("Lokal");
    private JButton multiButton= new JButton("Multiplayer");
    private JButton soundButton = new JButton(SoundIcon);
    Font robotoFont = new Font("Roboto", Font.BOLD, 45);

    public MainMenuView() {
        buildFrame();
        buildPanel();
    }

    public void buildPanel(){
        mainPanel.add(menuPanel, "MainMenu");
        lokalButton.setBounds(200, 200, 500, 500);
        multiButton.setBounds(800, 200, 500, 500);
        titelLabel.setBounds(550, 10, 700, 100);
        soundButton.setBounds(20, 20, 128, 128);

        lokalButton.setOpaque(true);
        multiButton.setOpaque(true);
        titelLabel.setOpaque(true);
        soundButton.setOpaque(true);

        titelLabel.setFont(robotoFont);
        lokalButton.setFont(robotoFont.deriveFont(50f));
        multiButton.setFont(robotoFont.deriveFont(50f));

        menuPanel.add(titelLabel);
        menuPanel.add(lokalButton);
        menuPanel.add(multiButton);
        menuPanel.add(soundButton);

       //mainPanel.add(menuPanel, "MainMenu");
    }

    public void showPanel(String panelName) {
        CardLayout cl = (CardLayout)mainPanel.getLayout();
        cl.show(mainPanel, panelName);
    }

    public void addPanel(JPanel panel, String name) {
        mainPanel.add(panel, name); // Neue Panels hinzufuegen
    }

    public void buildFrame() {
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(1500, 1000);
        frame.setLayout(null);

        JLabel backgroundLabel = new JLabel(new ImageIcon("graphics/mainmenubackground.png"));
        backgroundLabel.setBounds(0, 0, 1500, 1000);
        mainPanel.setBounds(0, 0, 1500, 1000);
       // mainPanel.setOpaque(true);

        frame.setContentPane(new JPanel(null));
        frame.getContentPane().add(backgroundLabel);
        frame.getContentPane().add(mainPanel);

        frame.setVisible(true);
        frame.setLocationRelativeTo(null);
    }

    public void toggleMute(){
        ImageIcon MuteIcon = new ImageIcon("graphics/sound button muted.png");
        if(soundButton.getIcon()==SoundIcon) {
            soundButton.setIcon(MuteIcon);
        }else{
            soundButton.setIcon(SoundIcon);
        }
    }

    public JFrame getFrame() {
        return frame;
    }

    public JButton getLocalButton() {
        return lokalButton;
    }

    public JButton getMultiButton() {
        return multiButton;
    }

    public JButton getSoundButton() {
        return soundButton;
    }

}
