import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class coinToss {
    // Frame
    private JFrame frame = new JFrame("Zugreihenfolge");
    private JPanel mainPanel = new JPanel(new CardLayout()); // Panel mit CardLayout für Szenenwechsel
    private JLabel frameTitle = new JLabel("Zugreihenfolge", SwingConstants.CENTER);
    private JLabel messageLabel = new JLabel("", SwingConstants.CENTER); // Label für die Nachricht
    private int reihenfolge = 1; // Beispielhaft: 1 = Spieler 1 fängt an, 0 = Spieler 2 fängt an
    private Timer timer;

    coinToss() {
        // Erstelle Frame
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(1500, 1000);
        frame.setLocationRelativeTo(null);

        // Panel für die Startszene erstellen
        JPanel startPanel = new JPanel();
        startPanel.setLayout(new BorderLayout());

        // Nachricht basierend auf 'reihenfolge' einstellen
        String startMessage = (reihenfolge == 1)
                ? "Du fängst an, mach dich bereit..."
                : "Dein Gegner fängt an, mach dich bereit...";
        messageLabel.setText(startMessage);
        messageLabel.setFont(new Font("Arial", Font.BOLD, 24));
        startPanel.add(frameTitle, BorderLayout.NORTH);
        startPanel.add(messageLabel, BorderLayout.CENTER);

        // Panel zur Haupt-Panel hinzufügen
        mainPanel.add(startPanel, "start");

        // Beispielhaftes "Spielfeld" (nächste Szene)
        JPanel gamePanel = new JPanel();
        gamePanel.setLayout(new BorderLayout());
        JLabel gameLabel = new JLabel("Das Spiel beginnt!", SwingConstants.CENTER);
        gameLabel.setFont(new Font("Arial", Font.BOLD, 36));
        gamePanel.add(gameLabel, BorderLayout.CENTER);

        // GamePanel zu Haupt-Panel hinzufügen
        mainPanel.add(gamePanel, "game");

        // Frame-Layout einstellen
        frame.add(mainPanel);
        frame.setVisible(true);

        // Timer starten
        startTimer();
    }

    private void startTimer() {
        // Timer, der nach 3 Sekunden zum Spiel-Panel wechselt
        timer = new Timer(3000, new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                // Wechsel zum Spiel-Panel
                CardLayout cardLayout = (CardLayout) mainPanel.getLayout();
                cardLayout.show(mainPanel, "game");
                timer.stop(); // Timer stoppen
            }
        });
        timer.setRepeats(false); // Timer soll nur einmal ablaufen
        timer.start(); // Timer starten
    }
}





/*
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


    TODO:



public class coinToss {
    // Funktionshilfen


    // Frame
    JFrame frame = new JFrame("Zugreihenfolge");

    // Labels
    JLabel frameTitle = new JLabel("Zugreihenfolge");

    coinToss() {
        // Erstelle Frame
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(1500, 1000);

        // Layout Manager (absolute ositionierung)
        frame.setLayout(null);
    }
}*/