import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/*
    TODO:
    Back Button führt ins vorherige Fenster
    Spiel erstellen/beitreten geht ins nächste Fenster
    Gebrauchte Attribute werden übergeben (Semester Spielername etc.)
    Klasse mit Controller aufteilen
*/

public class startMultiplayerGame {
    // Funktionshilfen
    int semesterCounter = 1; // Semester Counter Label
    String PlayerNickname = "Spieler 1";

    // Grafiken
    ImageIcon backButtonIcon = new ImageIcon("graphics/backButton.png");
    ImageIcon humanPlayerIcon = new ImageIcon("graphics/humanPlayer.png");
    ImageIcon aiPlayerIcon = new ImageIcon("graphics/aiPlayer.png");

    // Labels
    JLabel frameTitle = new JLabel("Multiplayer Spiel");
    JLabel semesterlable = new JLabel("Semester");
    JLabel PlayerName = new JLabel("Name");
    JLabel PlayerIcon = new JLabel(humanPlayerIcon);
    JLabel semesterCounterLabel = new JLabel(String.valueOf(semesterCounter));

    // Buttons
    JButton backButton = new JButton(backButtonIcon);
    JButton PlayerLeftButton = new JButton("<-");
    JButton PlayerRightButton = new JButton("->");
    JButton semesterUpButton = new JButton("^");
    JButton semesterDownButton = new JButton("v");
    JButton createGameButton = new JButton("Spiel erstellen");
    JButton joinGameButton = new JButton("Spiel beitreten");

    // Textfelder
    JTextField PlayerTextField = new JTextField(20);

    // Method to create the Multiplayer Panel
    public JPanel createMultiplayerPanel(CardLayout cardLayout, JPanel mainPanel) {
        // Create a new JPanel for the multiplayer game
        JPanel multiplayerPanel = new JPanel();
        multiplayerPanel.setLayout(null);

        // Erstelle Label
        frameTitle.setBounds(20, 20, 200, 30);
        multiplayerPanel.add(frameTitle);

        semesterlable.setBounds(700, 300, 200, 30);
        multiplayerPanel.add(semesterlable);

        PlayerName.setBounds(50, 625, 200, 30);
        multiplayerPanel.add(PlayerName);

        PlayerIcon.setBounds(75, 400, 200, 128);
        multiplayerPanel.add(PlayerIcon);

        semesterCounterLabel.setBounds(725, 475, 50, 50); // zwischen den Up/Down-Buttons
        semesterCounterLabel.setHorizontalAlignment(SwingConstants.CENTER);
        multiplayerPanel.add(semesterCounterLabel);

        // Erstellt Buttons
        backButton.setBounds(1380, 20, 80, 80);
        multiplayerPanel.add(backButton);

        PlayerLeftButton.setBounds(50, 450, 50, 50);
        multiplayerPanel.add(PlayerLeftButton);

        PlayerRightButton.setBounds(250, 450, 50, 50);
        multiplayerPanel.add(PlayerRightButton);

        semesterUpButton.setBounds(725, 400, 50, 50);
        multiplayerPanel.add(semesterUpButton);

        semesterDownButton.setBounds(725, 550, 50, 50);
        multiplayerPanel.add(semesterDownButton);

        joinGameButton.setBounds(1100, 350, 200, 50);
        multiplayerPanel.add(joinGameButton);

        createGameButton.setBounds(1100, 550, 200, 50);
        multiplayerPanel.add(createGameButton);

        // Erstellt Textfelder
        PlayerTextField.setBounds(50, 650, 250, 50);
        multiplayerPanel.add(PlayerTextField);

        //ZUSATZ
        PlayerTextField.setText(PlayerNickname);

        // ActionListener für die Buttons
        // SEMESTERBUTTONS
        semesterUpButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (semesterCounter < 6) {
                    semesterCounter++;
                    semesterCounterLabel.setText(String.valueOf(semesterCounter));
                }
            }
        });

        semesterDownButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (semesterCounter > 1) {  // Verhindert, dass der Wert unter 1 fällt
                    semesterCounter--;
                    semesterCounterLabel.setText(String.valueOf(semesterCounter));
                }
            }
        });

        // PLAYERTOGGLEBUTTONS
        PlayerLeftButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                toggleLeftPlayerIcon();
                updateTextFields();
            }
        });

        PlayerRightButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                toggleLeftPlayerIcon();
                updateTextFields();
            }
        });

        // ActionListener für den "Back" Button, um zum vorherigen Panel zurückzukehren
        backButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                cardLayout.show(mainPanel, "localGamePanel");
            }
        });

        return multiplayerPanel;
    }

    // TOGGLE METHODEN
    private void toggleLeftPlayerIcon() {
        if (PlayerIcon.getIcon() == humanPlayerIcon) {
            PlayerIcon.setIcon(aiPlayerIcon);
        } else {
            PlayerIcon.setIcon(humanPlayerIcon);
        }
    }

    private void updateTextFields() {
        if (PlayerIcon.getIcon() == humanPlayerIcon) {
            PlayerTextField.setText(PlayerNickname);
        } else {
            PlayerTextField.setText("Leicht");
        }
    }
}
